﻿using System;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using Telerik.Windows.Persistence.Services;
using Telerik.Windows.Controls;
using Telerik.Windows.Persistence.Storage;
using Telerik.Windows.Persistence;

namespace GridViewSerialization
{
	public partial class MainPage : UserControl
	{
		System.IO.Stream stream;
		public MainPage()
		{
			InitializeComponent();
			// register the custom property provider for the RadGridView:
			ServiceProvider.RegisterPersistenceProvider<ICustomPropertyProvider>(typeof(RadGridView), new GridViewCustomPropertyProvider());
			this.DataContext = ExamplesDB.GetCustomers();
            this.EnsureLoadState();
		}

        private void Save(object sender, RoutedEventArgs e)
        {
            PersistenceManager manager = new PersistenceManager();
            this.stream = manager.Save(this.radGridView);
            this.EnsureLoadState();
        }

        private void Load(object sender, RoutedEventArgs e)
        {
            this.stream.Position = 0L;
            PersistenceManager manager = new PersistenceManager();
            manager.Load(this.radGridView, this.stream);
            this.EnsureLoadState();
        }

        private bool CanLoad()
        {
            return this.stream != null && this.stream.Length > 0;
        }

        private void EnsureLoadState()
        {
            this.buttonLoad.IsEnabled = this.CanLoad();
        }

        private void CheckBox_Checked(object sender, RoutedEventArgs e)
        {

        }

        private void chStandard_Unchecked(object sender, RoutedEventArgs e)
        {

        }
	}
}
